import { core } from 'nexus';
export declare type RelayGlobalIdPluginConfig<TypeName extends string = any, FieldName extends string = any> = {
    nexusFieldName?: string;
    nexusSchemaImportId?: string;
    relayGlobalIdPluginImportId?: string;
    /**
     * Defaults to true - Adds a new ID! field called `raw${uppercase(fieldName)}`, where `fieldName` is `t.relayGlobalId(fieldName)`,
     *  with the original value of the field.
     *
     * It's also possible to pass a string with a different name for the field
     *
     * You can also set this in a per field basis
     */
    shouldAddRawId?: boolean | string;
    /**
     * If no resolve is supplied, the default value to be used as global ID will be root[field]
     *
     * This defaults to the fieldName used when calling relayGlobalId(fieldName)
     *
     * If a resolve is passed, this is ignored
     *
     * You can also set this in a per field basis
     */
    field?: string;
    /**
     * You can use this to specificy your own resolve function for the ID
     *
     * You can also set this in a per field basis
     */
    resolve?: core.FieldResolver<TypeName, FieldName>;
    nonNullDefaults?: Omit<core.NonNullConfig, 'input'>;
};
export declare type RelayGlobalIdNexusFieldConfig<TypeName extends string = any, FieldName extends string = any> = {
    /**
     * If no resolve is supplied, the default value to be used as global ID will be root[field]
     *
     * This defaults to the fieldName used when calling relayGlobalId(fieldName)
     *
     * If a resolve is passed, this is ignored
     */
    field?: string;
    /**
     * Defaults to true - Adds a new ID! field called `raw${uppercase(fieldName)}`, where `fieldName` is `t.relayGlobalId(fieldName)`,
     *  with the original value of the field.
     *
     * It's also possible to pass a string with a different name for the field
     */
    shouldAddRawId?: boolean | string;
    /**
     * Defaults to the parent type of the current field.
     */
    typeName?: string;
    /**
     * You can use this to specificy your own resolve function for the ID
     */
    resolve?: core.FieldResolver<TypeName, FieldName>;
} & NexusGenPluginFieldConfig<TypeName, FieldName>;
export declare function relayGlobalIdPlugin(pluginConfig?: RelayGlobalIdPluginConfig): core.NexusPlugin;
